---
title: image()
slug: Web/CSS/image()
tags:
  - CSS
  - CSS Function
  - CSS Images
  - Function
  - Reference
  - Web
---
<div>{{CSSRef}}{{SeeCompatTable}}</div>

<p>The <strong><code>image()</code></strong> <a href="/en-US/docs/CSS" title="CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> defines an {{CSSxRef("&lt;image&gt;")}} in a similar fashion to the {{CSSxRef("&lt;url&gt;")}} function, but with added functionality including specifying the image's directionality, specifying fallback images for when the preferred image is not supported, displaying just a part of that image defined by a media fragment, and specifying a solid color as a fallback in case none of the specified images are able to be rendered.</p>

<div class="notecard note">
<p><strong>Disambiguation:</strong> {{DOMxRef("HTMLImageElement/Image", '<code>Image()</code>, the <code>HTMLImageElement</code> constructor', '', 1)}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax("image()")}}</pre>

<p>where:</p>

<dl>
 <dt><code>image-tags</code>{{Optional_Inline}}</dt>
 <dd>The directionality of the image, either <code>ltr</code> for left-to-right or <code>rtl</code> for right-to-left.</dd>
 <dt><code>image-src</code> {{Optional_Inline}}</dt>
 <dd>Zero or more {{CSSxRef("&lt;url&gt;")}}s or {{CSSxRef("&lt;string&gt;")}}s specifying the image sources, with optional image fragment identifiers.</dd>
 <dt><code>color</code>{{Optional_Inline}}</dt>
 <dd>A color, specifying a solid background color to use as a fallback if no <code>image-src</code> is found, supported, or declared.</dd>
</dl>

<h3 id="Bi-directional_awareness">Bi-directional awareness</h3>

<p>The first, optional parameter of the <code>image()</code> notation is the directionality of the image. If included, and the image is used on an element with opposite directionality, the image will be flipped horizontally in horizontal writing modes. If the directionality is omitted, the image won't be flipped if the language direction is changed.</p>

<h3 id="Image_fragments">Image fragments</h3>

<p>One key difference between <code>url()</code> and <code>image()</code> is the ability to add a media fragment identifier — a starting point along the x and y axis, along with a width and height — onto the image source to display only a section of the source image. The section of the image defined in the parameter becomes a standalone image. The syntax looks like so:</p>

<pre class="brush: css; notranslate">background-image: image('myimage.webp#xywh=0,20,40,60');</pre>

<p>The background image of the element will be the portion of the image<em> myImage.webp</em> that starts at the coordinate 0px, 20px (the top left hand corner) and is 40px wide and 60px tall.</p>

<p>The <code>#xywh=#,#,#,#</code> media fragment syntax takes four comma separated numeric values. The first two represent the X and Y coordates for the starting point of the box that will be created. The third value is the width of the box, and the last value is the height. By default, these are pixel values. The <a href="https://www.w3.org/TR/media-frags/#naming-space">spacial dimension definition in the media specification</a> indicates that percentages will be supported as well:</p>

<pre class="brush: css; notranslate">xywh=160,120,320,240        /* results in a 320x240 image at x=160 and y=120 */
xywh=pixel:160,120,320,240  /* results in a 320x240 image at x=160 and y=120 */
xywh=percent:25,25,50,50    /* results in a 50%x50% image at x=25% and y=25% */</pre>

<p>The image fragments can be used in <code>url()</code> notation as well. The <code>#xywh=#,#,#,#</code> media fragment syntax is 'backwards compatible' in that a media fragment will be ignored if not understood, and won't break the source call when used with <code>url()</code>. If the browser doesn't understand the media fragments notation, it ignores the fragment, displaying the entire image.</p>

<p>Browsers that understand <code>image()</code> also understand the fragment notation. Therefore, if the fragment is not understood within <code>image()</code>, the image will be considered invalid.</p>

<h3 id="Color_fallback">Color fallback</h3>

<p>If a color is specified in <code>image()</code> along with your image sources, it acts as a fallback if the images are invalid and do not appear. In such cases, the <code>image()</code> function renders as if no image were included, generating a solid-color image. As a use case, consider a dark image being used as a background for some white text. A dark background color may be needed for foreground text to be legible, if the image does not render.</p>

<p>Omitting image sources while including a color is valid and creates a color swatch. Unlike declaring a {{CSSxRef("background-color")}}, which is placed under or behind all the background images, this can be used to put (generally semi-transparent) colors over other images.</p>

<p>The size of the color swatch can be set with the {{CSSxRef("background-size")}} property. This is different from the <code>background-color</code>, which sets a color to cover the entire element. Both <code>image(color)</code> and <code>background-color</code> placements are impacted by the {{CSSxRef("background-clip")}} and {{CSSxRef("background-origin")}} properties.</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Browsers do not provide any special information on background images to assistive technology. This is important primarily for screen readers, as a screen reader will not announce its presence and therefore convey nothing to its users. If the image contains information critical to understanding the page's overall purpose, it is better to describe it semantically in the document.</p>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable#Guideline_1.1_%E2%80%94_Providing_text_alternatives_for_non-text_content">MDN Understanding WCAG, Guideline 1.1 explanations</a></li>
 <li><a href="https://www.w3.org/TR/2016/NOTE-UNDERSTANDING-WCAG20-20161007/text-equiv-all.html">Understanding Success Criterion 1.1.1 | W3C Understanding WCAG 2.0</a></li>
</ul>

<p>This feature can help improve accessibility by providing a fallback color when an image fails to load. While this can and should be done by including a background-color on every background image, the CSS <code>image()</code> function allows adding allows only including background colors should an image fail to load, which means you can add a fall back color should a transparent PNG/GIF/WebP not load.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Directionally-sensitive_images">Directionally-sensitive images</h3>

<pre class="brush: html; notranslate">&lt;ul&gt;
  &lt;li dir="ltr"&gt;Bullet is a right facing arrow on the left&lt;/li&gt;
  &lt;li dir="rtl"&gt;Bullet is the same arrow, flipped to point left.&lt;/li&gt;
&lt;/ul&gt;</pre>

<pre class="brush: css; notranslate">ul {
  list-style-image: image(ltr 'https://mdn.mozillademos.org/files/16412/rightarrow.png');
}</pre>

<p>In the left-to-right list items — those with <code>dir="ltr"</code> set on the element itself or inheriting the directionality from an ancestor or default value for the page — the image will be used as-is. List items with <code>dir="rtl"</code> set on the <code>&lt;li&gt;</code> or inheriting the right-to-left directionality from an ancestor, such as documents set to Arabic or Hebrew, will have the bullet display on the right, horizontally flippled, as if <code>transform: scalex(-1)</code> had been set. The text will also be displayed left-to-right.</p>

<p>{{EmbedLiveSample("Directionally-sensitive_images", "100%", 200)}}</p>

<h3 id="Displaying_a_section_of_the_background_image">Displaying a section of the background image</h3>

<pre class="brush: html; notranslate">&lt;div class="box"&gt;Hover over me. What cursor do you see?&lt;/div&gt;
</pre>

<pre class="brush: css; notranslate">.box:hover {
  cursor: image("https://mdn.mozillademos.org/files/16411/sprite.png#xywh=32,64,16,16");
}</pre>

<p>When the user hovers over the box, the cursor will change to display the 16x16 px section of the sprite image, starting at x=32 and y=64.</p>

<p>{{EmbedLiveSample("Displaying_a_section_of_the_background_image", "100%", 100)}}</p>

<h3 id="Providing_fallback_images">Providing fallback images</h3>

<pre class="brush: css; notranslate">.help::before {
  content: image("try.webp", "try.svg", "try.gif");
}</pre>

<p>In this example, the browser will display an image as generated content before the content of the element with the class of <code>help</code>. The image displayed will be a WebP image, if WebP is supported. If not, the SVG example will be shown. If SVG is not supported, the GIF version will display.</p>

<div class="hidden">
<p>{{EmbedLiveSample("Providing_fallback_images", "100%", 200)}}</p>
</div>

<h3 id="Putting_color_on_top_of_a_background_image">Putting color on top of a background image</h3>

<div class="hidden">
<pre class="brush: css; notranslate">.quarterlogo {height: 200px; width: 200px; border: 1px solid;}</pre>
</div>

<pre class="brush: css; notranslate">.quarterlogo {
  background-image:
    image(rgba(0, 0, 0, 0.25)),
    url("https://mdn.mozillademos.org/files/12053/firefox.png");
  background-size: 25%;
  background-repeat: no-repeat;
}</pre>

<pre class="brush: html; notranslate">&lt;div class="quarterlogo"&gt;If supported, a quarter of this div has a darkened logo&lt;/div&gt;
</pre>

<p>The above will put a semi-transparent black mask over the Firefox logo background image. Had we used the {{cssxref("background-color")}} property instead, the color would have appeared behind the logo image instead of on top of it. Additionally, the entire container would have had the same background color. Because we used <code>image()</code> along with the {{CSSxRef("background-size")}} property (and prevented the image from repeating with the {{CSSxRef("background-repeat")}} property, the color swatch will only cover a quarter of the container.</p>

<p>{{EmbedLiveSample("Putting_color_on_top_of_a_background_image", "100%", 220)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS4 Images", "#image-notation", "image()")}}</td>
   <td>{{Spec2("CSS4 Images")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.image.image")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("&lt;image&gt;")}}</li>
 <li>{{CSSxRef("element")}}</li>
 <li>{{CSSxRef("&lt;url&gt;")}}</li>
 <li>{{CSSxRef("clip-path")}}</li>
 <li>{{CSSxRef("-moz-image-rect")}}</li>
 <li>{{CSSxRef("&lt;gradient&gt;")}}</li>
 <li>{{CSSxRef("image-set")}}</li>
 <li>{{CSSxRef("cross-fade")}}</li>
</ul>
